{-|
Module      : Async.Worker
Description : Abstract async worker implementation using the 'Queue' typeclass
Copyright   : (c) Gargantext, 2024-Present
License     : AGPL
Maintainer  : gargantext@iscpif.fr
Stability   : experimental
Portability : POSIX
-}

{-# LANGUAGE FlexibleContexts #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE ScopedTypeVariables #-}


module Async.Worker
  ( run
  , sendJob )
where


import Async.Worker.Broker
import Async.Worker.Types
import Control.Monad (forever)
import System.Timeout qualified as Timeout


run :: (Broker b) => b -> Queue -> IO ()
run broker queue = do
  -- state <- connect connParams
  createQueue broker queue
  forever loop
  where
    loop :: IO ()
    loop = do
      readMessageWaiting broker queue >>= handleMessage

    handleMessage :: (JobMessage m) => Job m -> IO ()
    handleMessage msg = do
      pure ()
      -- onMessageFetched broker queue msg

      -- (do
      --   let t = jobTimeout msg
      --   mTimeout <- Timeout.timeout t (handleJob broker msg)
      --   return ())

sendJob :: (Broker b) => b -> Queue -> message -> IO ()
sendJob _ _ _ = undefined


microsecond :: Int
microsecond = 10^6
